
//`#start header` -- edit after this line, do not edit this line
/* ============================================================================
 * File Name: Sync32_Core_v0_0.v
 * Version 0.0
 * 
 * Description:
 *   Sync32: Synchronizes 1 to 32 input signals to the clock 
 *   Compact substitute for standard Sync component 
 *   Can use external or internal clock  
 *
 * Note:
 *
 * ============================================================================
 * PROVIDED AS-IS, NO WARRANTY OF ANY KIND, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * FREE TO SHARE, USE AND MODIFY UNDER TERMS: CREATIVE COMMONS - SHARE ALIKE
 * ============================================================================
*/

`include "cypress.v"
`ifdef Sync32_Core_v0_0_ALREADY_INCLUDED
`else
`define Sync32_Core_v0_0_ALREADY_INCLUDED

//`#end` -- edit above this line, do not edit this line
// Generated on 03/07/2020 at 16:50
// Component: Sync32_Core_v0_0
module Sync32_Core_v0_0 (
	output  s_out_0,
	output  s_out_1,
	output  s_out_2,
	output  s_out_3,
	output  s_out_4,
	output  s_out_5,
	output  s_out_6,
	output  s_out_7,
	output [31:0] s_out,
	input   clock,
	input   s_in_0,
	input   s_in_1,
	input   s_in_2,
	input   s_in_3,
	input   s_in_4,
	input   s_in_5,
	input   s_in_6,
	input   s_in_7,
	input  [31:0] s_in // todo [31:0]
);
	parameter SignalWidth = 8;
	parameter ShowBus = 1;
    
//`#start body` -- edit after this line, do not edit this line


	wire   [SignalWidth-1: 0] a_in;     // internal input bus
	wire   [SignalWidth-1: 0] a_out;    // internal output bus

	genvar i;
    generate
    	for (i = 0 ; i < SignalWidth ; i = i + 1)
		begin
			cy_psoc3_sync INST (
			.clock	(clock),
			.sc_in	(a_in[i]),
			.sc_out	(a_out[i]));
		end
    endgenerate
    
    
    // output assignment
    generate 
        //if(ShowBus && SignalWidth > 1)
        if(ShowBus)
        begin: busOut
            assign a_in  = s_in;
            assign s_out = a_out;
        end
        else
        begin: bitwise    

            if (SignalWidth > 0) assign a_in[0] = s_in_0;
            if (SignalWidth > 0) assign s_out_0 = a_out[0];
       
            if (SignalWidth > 1) assign a_in[1] = s_in_1;
            if (SignalWidth > 1) assign s_out_1 = a_out[1];
        
            if (SignalWidth > 2) assign a_in[2] = s_in_2;
            if (SignalWidth > 2) assign s_out_2 = a_out[2];
        
            if (SignalWidth > 3) assign a_in[3] = s_in_3;
            if (SignalWidth > 3) assign s_out_3 = a_out[3];

            if (SignalWidth > 4) assign a_in[4] = s_in_4;
            if (SignalWidth > 4) assign s_out_4 = a_out[4];
        
            if (SignalWidth > 5) assign a_in[5] = s_in_5;
            if (SignalWidth > 5) assign s_out_5 = a_out[5];
        
            if (SignalWidth > 6) assign a_in[6] = s_in_6;
            if (SignalWidth > 6) assign s_out_6 = a_out[6];
        
            if (SignalWidth > 7) assign a_in[7] = s_in_7;
            if (SignalWidth > 7) assign s_out_7 = a_out[7];

        end 
        
    endgenerate


endmodule

`endif /* Sync32_Core_v0_0_ALREADY_INCLUDED */
//`#end` -- edit above this line, do not edit this line
//`#start footer` -- edit after this line, do not edit this line
//`#end` -- edit above this line, do not edit this line


/*

            if (SignalWidth > 0) begin
                assign a_in[0] = s_in_0;
                assign s_out_0 = a_out[0];
            end
        
            if (SignalWidth > 1) begin
                assign a_in[1] = s_in_1;
                assign s_out_1 = a_out[1];
            end
        
            if (SignalWidth > 2) begin
                assign a_in[2] = s_in_2;
                assign s_out_2 = a_out[2];
            end
        
            if (SignalWidth > 3) begin
                assign a_in[3] = s_in_3;
                assign s_out_3 = a_out[3];
            end
            
            if (SignalWidth > 4) begin
                assign a_in[4] = s_in_4;
                assign s_out_4 = a_out[4];
            end
        
            if (SignalWidth > 5) begin
                assign a_in[5] = s_in_5;
                assign s_out_5 = a_out[5];
            end
        
            if (SignalWidth > 6) begin
                assign a_in[6] = s_in_6;
                assign s_out_6 = a_out[6];
            end
        
            if (SignalWidth > 7) begin
                assign a_in[7] = s_in_7;
                assign s_out_7 = a_out[7];
            end
*/