/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using CyDesigner.Extensions.Common;
using CyDesigner.Extensions.Gde;

// The namespace is required to have the same name as the component for a customizer.
namespace Sync32_v0_0
{
    class CyCustomizer : ICyShapeCustomize_v1
    {
        const string INPUT_TERM_NAME = "s_in";  //inp terminal
        const string OUTPUT_TERM_NAME = "s_out"; //outp terminal


        public CyCustErr CustomizeShapes(ICyInstQuery_v1 instQuery, ICySymbolShapeEdit_v1 shapeEdit,
            ICyTerminalEdit_v1 termEdit)
        {
            CyCustErr err;

            // We leave the symbol as it is for symbol preview
            //if (instQuery.IsPreviewCanvas)
            //    return CyCustErr.OK;
            
            // Read Parameters
            CyCompDevParam WidthParam = instQuery.GetCommittedParam("SignalWidth");
            
            byte Width;
            err = WidthParam.TryGetValueAs<byte>(out Width);    if (err.IsNotOk) return err;
            
            // Read Parameters
            //CyCompDevParam WidthParam = instQuery.GetCommittedParam("SignalWidth");
            //byte Width = byte.Parse(WidthParam.Value);
            
            
            string inpTermName = termEdit.GetTermName(INPUT_TERM_NAME);
            byte maxBitIndex = (byte)(Width - 1);
            
            if (maxBitIndex != 0)
                err = termEdit.TerminalRename(inpTermName, string.Format("{0}[{1}:0]", INPUT_TERM_NAME, maxBitIndex.ToString())); 
            else
                err = termEdit.TerminalRename(inpTermName, string.Format("{0}", INPUT_TERM_NAME ));   
     
            if (err.IsNotOK) return err; 
            
            

            
            string outTermName = termEdit.GetTermName(OUTPUT_TERM_NAME);
            
            if (maxBitIndex != 0)
                err = termEdit.TerminalRename(outTermName, string.Format("{0}[{1}:0]", OUTPUT_TERM_NAME, maxBitIndex.ToString())); 
            else
                err = termEdit.TerminalRename(outTermName, string.Format("{0}", OUTPUT_TERM_NAME ));   
   
            if (err.IsNotOK) return err; 
          
            
   
            return CyCustErr.OK;
        }
    }
}

//[] END OF FILE
